#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <sql.h>
#include <sqlext.h>

int main(int argc, char **argv)
{
  HSTMT hstmt = SQL_NULL_HSTMT;
  SQLRETURN ret;
  SQLCHAR str[1024];
  SQLSMALLINT strl;
  SQLHENV env;
  SQLHDBC conn;
  char buf[1000];

  SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &env);
  SQLSetEnvAttr(env, SQL_ATTR_ODBC_VERSION, (void *) SQL_OV_ODBC3, 0);

  SQLAllocHandle(SQL_HANDLE_DBC, env, &conn);
  ret = SQLDriverConnect(conn, NULL, "DSN=psqlodbc_test_dsn;", SQL_NTS,
			 str, sizeof(str), &strl,
			 SQL_DRIVER_COMPLETE);
  if (SQL_SUCCEEDED(ret)) {
    printf("connected\n");
  } else {
    printf("failed to connect\n");
    exit(1);
  }

  ret = SQLAllocStmt(conn, &hstmt);
  if (!SQL_SUCCEEDED(ret))
  {
    printf("failed to allocate stmt handle");
    exit(1);
  }

  ret = SQLExecDirect(hstmt, (SQLCHAR *) "select * from public.too_short_view;", SQL_NTS);
  if (!SQL_SUCCEEDED(ret))
  {
    printf("select failed");
    exit(1);
  }

  ret = SQLFetch(hstmt);
  if (ret != SQL_SUCCESS)
  {
    printf("SQLFetch failed\n");
    exit(1);
  }

  ret = SQLGetData(hstmt, 2, SQL_C_CHAR, buf, sizeof(buf), NULL);
  if (!SQL_SUCCEEDED(ret))
  {
    printf("SQLGetData failed");
    exit(1);
  }
  printf("%s\n",buf);

  return 0;
}
